package dataspork.view;
import java.awt.*;
import java.awt.geom.*;
import dataspork.plot.*;
import dataspork.util.XYDataSource;
import dataspork.stat.grData;
import dataspork.util.ConstXYDataSource;

/**
  */
public class PairDistributionGraph {

  protected grData grd; 
  protected CoordRange range;
  protected Plot plot;
  protected PlotBox plotBox;
  protected XYPlot grPlot;
  protected Axis xAxis;
  protected Axis yAxis;

  /**
    */
  public PairDistributionGraph(grData grd) {
    this.grd=grd;
  //  range = new CoordRange( new AutoXRange(pairDistribution), 
  //                          new AutoYRange(pairDistribution));
     grSource source = new grSource(grd);
  //   ConstXYDataSource source = 
  //        new ConstXYDataSource(grd.getRGrid(),grd.getGr());
     range = new CoordRange(new AutoXRange(source),
                            new AutoYRange(source));
    //
    //Lay out the plot
    //
    plot = new Plot();
    plotBox = new PlotBox(range, new CoordRange(0,0,1,1));
    plot.addElement(plotBox);
    plotBox.addElement( grPlot = new XYPlot(source) );
    grPlot.setPaint(Color.red);
    plotBox.addElement(xAxis = new Axis(Axis.HORIZONTAL));
    plotBox.addElement(yAxis = new Axis(Axis.VERTICAL));
    plotBox.addElement( new PlotFrame() );
  }


  /**
    */
  public Plot getPlot() {
    return plot;
  }

  public class grSource implements XYDataSource {
       protected grData data;
       public grSource(grData grd){
         this.data = grd;
       }
       public double[] getXData() {
          return data.getRGrid();
       }
       public double[] getYData() {
          return data.getGr();
       }
       public double getXMin() {
 //         System.out.println("X min: "+data.getRGrid()[0]+"\n" );
          return data.getRGrid()[0];
       }
       public double getXMax() {
          double[] rg = data.getRGrid();
//          System.out.println("X max: "+rg[rg.length-1]+"\n" );
          return rg[rg.length-1];
       }
       public double getYMin() {
           return 0.0;
       }

       public double getYMax() {
//           System.out.println("Y max: "+data.grMax()+"\n" );
           return data.grMax();
       }

  }
}
