package dataspork.view;
import java.awt.*;
import java.awt.geom.*;
import dataspork.plot.*;
import dataspork.util.XYDataSource;
import dataspork.stat.skData;
import dataspork.util.ConstXYDataSource;

/**
  */
public class StructureFactorGraph {

  protected skData skd; 
  protected CoordRange range;
  protected Plot plot;
  protected PlotBox plotBox;
  protected XYPlot skPlot;
  protected Axis xAxis;
  protected Axis yAxis;

  /**
    */
  public StructureFactorGraph(skData skd) {
    this.skd=skd;
  //  range = new CoordRange( new AutoXRange(pairDistribution), 
  //                          new AutoYRange(pairDistribution));
     skSource source = new skSource(skd);
  //   ConstXYDataSource source = 
  //        new ConstXYDataSource(skd.getKGrid(),skd.getSk());
     range = new CoordRange(new AutoXRange(source),
                            new AutoYRange(source));
    //
    //Lay out the plot
    //
    plot = new Plot();
    plotBox = new PlotBox(range, new CoordRange(0,0,1,1));
    plot.addElement(plotBox);
    plotBox.addElement( skPlot = new XYPlot(source) );
    skPlot.setPaint(Color.red);
    plotBox.addElement(xAxis = new Axis(Axis.HORIZONTAL));
    plotBox.addElement(yAxis = new Axis(Axis.VERTICAL));
    plotBox.addElement( new PlotFrame() );
  }


  /**
    */
  public Plot getPlot() {
    return plot;
  }

  public class skSource implements XYDataSource {
       protected skData data;
       public skSource(skData skd){
         this.data = skd;
       }
       public double[] getXData() {
          return data.getKGrid();
       }
       public double[] getYData() {
          return data.getSk();
       }
       public double getXMin() {
 //         System.out.println("X min: "+data.getKGrid()[0]+"\n" );
          return data.getKGrid()[0];
       }
       public double getXMax() {
          double[] rg = data.getKGrid();
 //         System.out.println("X max: "+rg[rg.length-1]+"\n" );
          return rg[rg.length-1];
       }
       public double getYMin() {
           return 0.0;
       }

       public double getYMax() {
//           System.out.println("Y max: "+data.skMax()+"\n" );
           return data.skMax();
       }

  }
}
